diff --git a/external/fmt/test/format-test.cc b/external/fmt/test/format-test.cc
index 2a25566c..a8592ef0 100644
--- a/external/fmt/test/format-test.cc
+++ b/external/fmt/test/format-test.cc
@@ -5,112 +5,63 @@
 //
 // For the license information refer to format.h.
 
-#include <stdint.h>
-
-#include <cctype>
-#include <cfloat>
-#include <climits>
-#include <cmath>
-#include <cstring>
-#include <list>
-#include <memory>
-#include <string>
-
 // Check if fmt/format.h compiles with windows.h included before it.
 #ifdef _WIN32
 #  include <windows.h>
 #endif
-
-// Check if fmt/format.h compiles with the X11 index macro defined.
-#define index(x, y) no nice things
-
-#include "fmt/color.h"
+// clang-format off
 #include "fmt/format.h"
+// clang-format on
 
-#undef index
+#include <stdint.h>  // uint32_t
+
+#include <climits>      // INT_MAX
+#include <cmath>        // std::signbit
+#include <cstring>      // std::strlen
+#include <iterator>     // std::back_inserter
+#include <list>         // std::list
+#include <memory>       // std::unique_ptr
+#include <type_traits>  // std::is_default_constructible
 
-#include "gmock.h"
 #include "gtest-extra.h"
 #include "mock-allocator.h"
 #include "util.h"
 
-#undef ERROR
-
 using fmt::basic_memory_buffer;
-using fmt::format;
 using fmt::format_error;
 using fmt::memory_buffer;
+using fmt::runtime;
 using fmt::string_view;
-using fmt::wmemory_buffer;
-using fmt::wstring_view;
 using fmt::detail::max_value;
 
 using testing::Return;
 using testing::StrictMock;
 
-namespace {
-
-#if !FMT_GCC_VERSION || FMT_GCC_VERSION >= 408
-template <typename Char, typename T> bool check_enabled_formatter() {
-  static_assert(std::is_default_constructible<fmt::formatter<T, Char>>::value,
-                "");
-  return true;
-}
-
-template <typename Char, typename... T> void check_enabled_formatters() {
-  auto dummy = {check_enabled_formatter<Char, T>()...};
-  (void)dummy;
-}
-
-TEST(FormatterTest, TestFormattersEnabled) {
-  check_enabled_formatters<char, bool, char, signed char, unsigned char, short,
-                           unsigned short, int, unsigned, long, unsigned long,
-                           long long, unsigned long long, float, double,
-                           long double, void*, const void*, char*, const char*,
-                           std::string, std::nullptr_t>();
-  check_enabled_formatters<wchar_t, bool, wchar_t, signed char, unsigned char,
-                           short, unsigned short, int, unsigned, long,
-                           unsigned long, long long, unsigned long long, float,
-                           double, long double, void*, const void*, wchar_t*,
-                           const wchar_t*, std::wstring, std::nullptr_t>();
-}
-#endif
-
-// Format value using the standard library.
-template <typename Char, typename T>
-void std_format(const T& value, std::basic_string<Char>& result) {
-  std::basic_ostringstream<Char> os;
-  os << value;
-  result = os.str();
-}
-
-#ifdef __MINGW32__
-// Workaround a bug in formatting long double in MinGW.
-void std_format(long double value, std::string& result) {
-  char buffer[100];
-  safe_sprintf(buffer, "%Lg", value);
-  result = buffer;
-}
-void std_format(long double value, std::wstring& result) {
-  wchar_t buffer[100];
-  swprintf(buffer, L"%Lg", value);
-  result = buffer;
-}
-#endif
-}  // namespace
+enum { buffer_size = 256 };
 
 struct uint32_pair {
   uint32_t u[2];
 };
 
-TEST(UtilTest, BitCast) {
+TEST(util_test, bit_cast) {
   auto s = fmt::detail::bit_cast<uint32_pair>(uint64_t{42});
   EXPECT_EQ(fmt::detail::bit_cast<uint64_t>(s), 42ull);
-  s = fmt::detail::bit_cast<uint32_pair>(uint64_t(~0ull));
+  s = fmt::detail::bit_cast<uint32_pair>(~uint64_t{0});
   EXPECT_EQ(fmt::detail::bit_cast<uint64_t>(s), ~0ull);
 }
 
-TEST(UtilTest, Increment) {
+// Increment a number in a string.
+void increment(char* s) {
+  for (int i = static_cast<int>(std::strlen(s)) - 1; i >= 0; --i) {
+    if (s[i] != '9') {
+      ++s[i];
+      break;
+    }
+    s[i] = '0';
+  }
+}
+
+TEST(util_test, increment) {
   char s[10] = "123";
   increment(s);
   EXPECT_STREQ("124", s);
@@ -124,89 +75,52 @@ TEST(UtilTest, Increment) {
   EXPECT_STREQ("200", s);
 }
 
-TEST(UtilTest, ParseNonnegativeInt) {
-  if (max_value<int>() != static_cast<int>(static_cast<unsigned>(1) << 31)) {
-    fmt::print("Skipping parse_nonnegative_int test\n");
-    return;
-  }
-  fmt::string_view s = "10000000000";
+TEST(util_test, parse_nonnegative_int) {
+  auto s = fmt::string_view("10000000000");
   auto begin = s.begin(), end = s.end();
-  EXPECT_THROW_MSG(
-      parse_nonnegative_int(begin, end, fmt::detail::error_handler()),
-      fmt::format_error, "number is too big");
+  EXPECT_EQ(fmt::detail::parse_nonnegative_int(begin, end, -1), -1);
   s = "2147483649";
   begin = s.begin();
   end = s.end();
-  EXPECT_THROW_MSG(
-      parse_nonnegative_int(begin, end, fmt::detail::error_handler()),
-      fmt::format_error, "number is too big");
-}
-
-TEST(IteratorTest, CountingIterator) {
-  fmt::detail::counting_iterator it;
-  auto prev = it++;
-  EXPECT_EQ(prev.count(), 0);
-  EXPECT_EQ(it.count(), 1);
-}
-
-TEST(IteratorTest, TruncatingIterator) {
-  char* p = nullptr;
-  fmt::detail::truncating_iterator<char*> it(p, 3);
-  auto prev = it++;
-  EXPECT_EQ(prev.base(), p);
-  EXPECT_EQ(it.base(), p + 1);
-}
-
-TEST(IteratorTest, TruncatingBackInserter) {
-  std::string buffer;
-  auto bi = std::back_inserter(buffer);
-  fmt::detail::truncating_iterator<decltype(bi)> it(bi, 2);
-  *it++ = '4';
-  *it++ = '2';
-  *it++ = '1';
-  EXPECT_EQ(buffer.size(), 2);
-  EXPECT_EQ(buffer, "42");
-}
-
-TEST(IteratorTest, IsOutputIterator) {
-  EXPECT_TRUE(fmt::detail::is_output_iterator<char*>::value);
-  EXPECT_FALSE(fmt::detail::is_output_iterator<const char*>::value);
-  EXPECT_FALSE(fmt::detail::is_output_iterator<std::string>::value);
-  EXPECT_TRUE(fmt::detail::is_output_iterator<
-              std::back_insert_iterator<std::string>>::value);
-  EXPECT_TRUE(fmt::detail::is_output_iterator<std::string::iterator>::value);
-  EXPECT_FALSE(
-      fmt::detail::is_output_iterator<std::string::const_iterator>::value);
-  EXPECT_FALSE(fmt::detail::is_output_iterator<std::list<char>>::value);
-  EXPECT_TRUE(
-      fmt::detail::is_output_iterator<std::list<char>::iterator>::value);
-  EXPECT_FALSE(
-      fmt::detail::is_output_iterator<std::list<char>::const_iterator>::value);
-  EXPECT_FALSE(fmt::detail::is_output_iterator<uint32_pair>::value);
-}
-
-TEST(MemoryBufferTest, Ctor) {
-  basic_memory_buffer<char, 123> buffer;
-  EXPECT_EQ(static_cast<size_t>(0), buffer.size());
-  EXPECT_EQ(123u, buffer.capacity());
+  EXPECT_EQ(fmt::detail::parse_nonnegative_int(begin, end, -1), -1);
 }
 
-static void check_forwarding(mock_allocator<int>& alloc,
-                             allocator_ref<mock_allocator<int>>& ref) {
-  int mem;
-  // Check if value_type is properly defined.
-  allocator_ref<mock_allocator<int>>::value_type* ptr = &mem;
-  // Check forwarding.
-  EXPECT_CALL(alloc, allocate(42)).WillOnce(testing::Return(ptr));
-  ref.allocate(42);
-  EXPECT_CALL(alloc, deallocate(ptr, 42));
-  ref.deallocate(ptr, 42);
+TEST(util_test, utf8_to_utf16) {
+  auto u = fmt::detail::utf8_to_utf16("лошадка");
+  EXPECT_EQ(L"\x043B\x043E\x0448\x0430\x0434\x043A\x0430", u.str());
+  EXPECT_EQ(7, u.size());
+  // U+10437 { DESERET SMALL LETTER YEE }
+  EXPECT_EQ(L"\xD801\xDC37", fmt::detail::utf8_to_utf16("𐐷").str());
+  EXPECT_THROW_MSG(fmt::detail::utf8_to_utf16("\xc3\x28"), std::runtime_error,
+                   "invalid utf8");
+  EXPECT_THROW_MSG(fmt::detail::utf8_to_utf16(fmt::string_view("л", 1)),
+                   std::runtime_error, "invalid utf8");
+  EXPECT_EQ(L"123456", fmt::detail::utf8_to_utf16("123456").str());
 }
 
-TEST(AllocatorTest, allocator_ref) {
+TEST(util_test, utf8_to_utf16_empty_string) {
+  auto s = std::string();
+  auto u = fmt::detail::utf8_to_utf16(s.c_str());
+  EXPECT_EQ(L"", u.str());
+  EXPECT_EQ(s.size(), u.size());
+}
+
+TEST(util_test, allocator_ref) {
+  using test_allocator_ref = allocator_ref<mock_allocator<int>>;
+  auto check_forwarding = [](mock_allocator<int>& alloc,
+                             test_allocator_ref& ref) {
+    int mem;
+    // Check if value_type is properly defined.
+    allocator_ref<mock_allocator<int>>::value_type* ptr = &mem;
+    // Check forwarding.
+    EXPECT_CALL(alloc, allocate(42)).WillOnce(Return(ptr));
+    ref.allocate(42);
+    EXPECT_CALL(alloc, deallocate(ptr, 42));
+    ref.deallocate(ptr, 42);
+  };
+
   StrictMock<mock_allocator<int>> alloc;
-  typedef allocator_ref<mock_allocator<int>> test_allocator_ref;
-  test_allocator_ref ref(&alloc);
+  auto ref = test_allocator_ref(&alloc);
   // Check if allocator_ref forwards to the underlying allocator.
   check_forwarding(alloc, ref);
   test_allocator_ref ref2(ref);
@@ -217,26 +131,80 @@ TEST(AllocatorTest, allocator_ref) {
   check_forwarding(alloc, ref3);
 }
 
-typedef allocator_ref<std::allocator<char>> TestAllocator;
+TEST(util_test, format_system_error) {
+  fmt::memory_buffer message;
+  fmt::format_system_error(message, EDOM, "test");
+  auto ec = std::error_code(EDOM, std::generic_category());
+  EXPECT_EQ(to_string(message), std::system_error(ec, "test").what());
+  message = fmt::memory_buffer();
+
+  // Check if std::allocator throws on allocating max size_t / 2 chars.
+  size_t max_size = max_value<size_t>() / 2;
+  bool throws_on_alloc = false;
+  try {
+    auto alloc = std::allocator<char>();
+    alloc.deallocate(alloc.allocate(max_size), max_size);
+  } catch (const std::bad_alloc&) {
+    throws_on_alloc = true;
+  }
+  if (!throws_on_alloc) {
+    fmt::print("warning: std::allocator allocates {} chars", max_size);
+    return;
+  }
+}
+
+TEST(util_test, system_error) {
+  auto test_error = fmt::system_error(EDOM, "test");
+  auto ec = std::error_code(EDOM, std::generic_category());
+  EXPECT_STREQ(test_error.what(), std::system_error(ec, "test").what());
+  EXPECT_EQ(test_error.code(), ec);
 
-static void check_move_buffer(
-    const char* str, basic_memory_buffer<char, 5, TestAllocator>& buffer) {
-  std::allocator<char>* alloc = buffer.get_allocator().get();
-  basic_memory_buffer<char, 5, TestAllocator> buffer2(std::move(buffer));
-  // Move shouldn't destroy the inline content of the first buffer.
-  EXPECT_EQ(str, std::string(&buffer[0], buffer.size()));
-  EXPECT_EQ(str, std::string(&buffer2[0], buffer2.size()));
-  EXPECT_EQ(5u, buffer2.capacity());
-  // Move should transfer allocator.
-  EXPECT_EQ(nullptr, buffer.get_allocator().get());
-  EXPECT_EQ(alloc, buffer2.get_allocator().get());
+  auto error = std::system_error(std::error_code());
+  try {
+    throw fmt::system_error(EDOM, "test {}", "error");
+  } catch (const std::system_error& e) {
+    error = e;
+  }
+  fmt::memory_buffer message;
+  fmt::format_system_error(message, EDOM, "test error");
+  EXPECT_EQ(error.what(), to_string(message));
+  EXPECT_EQ(error.code(), std::error_code(EDOM, std::generic_category()));
 }
 
-TEST(MemoryBufferTest, MoveCtorInlineBuffer) {
-  std::allocator<char> alloc;
-  basic_memory_buffer<char, 5, TestAllocator> buffer((TestAllocator(&alloc)));
+TEST(util_test, report_system_error) {
+  fmt::memory_buffer out;
+  fmt::format_system_error(out, EDOM, "test error");
+  out.push_back('\n');
+  EXPECT_WRITE(stderr, fmt::report_system_error(EDOM, "test error"),
+               to_string(out));
+}
+
+TEST(memory_buffer_test, ctor) {
+  basic_memory_buffer<char, 123> buffer;
+  EXPECT_EQ(static_cast<size_t>(0), buffer.size());
+  EXPECT_EQ(123u, buffer.capacity());
+}
+
+using std_allocator = allocator_ref<std::allocator<char>>;
+
+TEST(memory_buffer_test, move_ctor_inline_buffer) {
+  auto check_move_buffer =
+      [](const char* str, basic_memory_buffer<char, 5, std_allocator>& buffer) {
+        std::allocator<char>* alloc = buffer.get_allocator().get();
+        basic_memory_buffer<char, 5, std_allocator> buffer2(std::move(buffer));
+        // Move shouldn't destroy the inline content of the first buffer.
+        EXPECT_EQ(str, std::string(&buffer[0], buffer.size()));
+        EXPECT_EQ(str, std::string(&buffer2[0], buffer2.size()));
+        EXPECT_EQ(5u, buffer2.capacity());
+        // Move should transfer allocator.
+        EXPECT_EQ(nullptr, buffer.get_allocator().get());
+        EXPECT_EQ(alloc, buffer2.get_allocator().get());
+      };
+
+  auto alloc = std::allocator<char>();
+  basic_memory_buffer<char, 5, std_allocator> buffer((std_allocator(&alloc)));
   const char test[] = "test";
-  buffer.append(test, test + 4);
+  buffer.append(string_view(test, 4));
   check_move_buffer("test", buffer);
   // Adding one more character fills the inline buffer, but doesn't cause
   // dynamic allocation.
@@ -244,24 +212,24 @@ TEST(MemoryBufferTest, MoveCtorInlineBuffer) {
   check_move_buffer("testa", buffer);
 }
 
-TEST(MemoryBufferTest, MoveCtorDynamicBuffer) {
-  std::allocator<char> alloc;
-  basic_memory_buffer<char, 4, TestAllocator> buffer((TestAllocator(&alloc)));
+TEST(memory_buffer_test, move_ctor_dynamic_buffer) {
+  auto alloc = std::allocator<char>();
+  basic_memory_buffer<char, 4, std_allocator> buffer((std_allocator(&alloc)));
   const char test[] = "test";
   buffer.append(test, test + 4);
   const char* inline_buffer_ptr = &buffer[0];
   // Adding one more character causes the content to move from the inline to
   // a dynamically allocated buffer.
   buffer.push_back('a');
-  basic_memory_buffer<char, 4, TestAllocator> buffer2(std::move(buffer));
+  basic_memory_buffer<char, 4, std_allocator> buffer2(std::move(buffer));
   // Move should rip the guts of the first buffer.
   EXPECT_EQ(inline_buffer_ptr, &buffer[0]);
   EXPECT_EQ("testa", std::string(&buffer2[0], buffer2.size()));
   EXPECT_GT(buffer2.capacity(), 4u);
 }
 
-static void check_move_assign_buffer(const char* str,
-                                     basic_memory_buffer<char, 5>& buffer) {
+void check_move_assign_buffer(const char* str,
+                              basic_memory_buffer<char, 5>& buffer) {
   basic_memory_buffer<char, 5> buffer2;
   buffer2 = std::move(buffer);
   // Move shouldn't destroy the inline content of the first buffer.
@@ -270,7 +238,7 @@ static void check_move_assign_buffer(const char* str,
   EXPECT_EQ(5u, buffer2.capacity());
 }
 
-TEST(MemoryBufferTest, MoveAssignment) {
+TEST(memory_buffer_test, move_assignment) {
   basic_memory_buffer<char, 5> buffer;
   const char test[] = "test";
   buffer.append(test, test + 4);
@@ -291,14 +259,10 @@ TEST(MemoryBufferTest, MoveAssignment) {
   EXPECT_GT(buffer2.capacity(), 5u);
 }
 
-TEST(MemoryBufferTest, Grow) {
+TEST(memory_buffer_test, grow) {
   typedef allocator_ref<mock_allocator<int>> Allocator;
-  typedef basic_memory_buffer<int, 10, Allocator> Base;
   mock_allocator<int> alloc;
-  struct TestMemoryBuffer : Base {
-    TestMemoryBuffer(Allocator alloc) : Base(alloc) {}
-    void grow(size_t size) { Base::grow(size); }
-  } buffer((Allocator(&alloc)));
+  basic_memory_buffer<int, 10, Allocator> buffer((Allocator(&alloc)));
   buffer.resize(7);
   using fmt::detail::to_unsigned;
   for (int i = 0; i < 7; ++i) buffer[to_unsigned(i)] = i * i;
@@ -306,7 +270,7 @@ TEST(MemoryBufferTest, Grow) {
   int mem[20];
   mem[7] = 0xdead;
   EXPECT_CALL(alloc, allocate(20)).WillOnce(Return(mem));
-  buffer.grow(20);
+  buffer.try_reserve(20);
   EXPECT_EQ(20u, buffer.capacity());
   // Check if size elements have been copied
   for (int i = 0; i < 7; ++i) EXPECT_EQ(i * i, buffer[to_unsigned(i)]);
@@ -315,15 +279,15 @@ TEST(MemoryBufferTest, Grow) {
   EXPECT_CALL(alloc, deallocate(mem, 20));
 }
 
-TEST(MemoryBufferTest, Allocator) {
-  typedef allocator_ref<mock_allocator<char>> TestAllocator;
-  basic_memory_buffer<char, 10, TestAllocator> buffer;
+TEST(memory_buffer_test, allocator) {
+  using test_allocator = allocator_ref<mock_allocator<char>>;
+  basic_memory_buffer<char, 10, test_allocator> buffer;
   EXPECT_EQ(nullptr, buffer.get_allocator().get());
   StrictMock<mock_allocator<char>> alloc;
   char mem;
   {
-    basic_memory_buffer<char, 10, TestAllocator> buffer2(
-        (TestAllocator(&alloc)));
+    basic_memory_buffer<char, 10, test_allocator> buffer2(
+        (test_allocator(&alloc)));
     EXPECT_EQ(&alloc, buffer2.get_allocator().get());
     size_t size = 2 * fmt::inline_buffer_size;
     EXPECT_CALL(alloc, allocate(size)).WillOnce(Return(&mem));
@@ -332,21 +296,22 @@ TEST(MemoryBufferTest, Allocator) {
   }
 }
 
-TEST(MemoryBufferTest, ExceptionInDeallocate) {
-  typedef allocator_ref<mock_allocator<char>> TestAllocator;
+TEST(memory_buffer_test, exception_in_deallocate) {
+  using test_allocator = allocator_ref<mock_allocator<char>>;
   StrictMock<mock_allocator<char>> alloc;
-  basic_memory_buffer<char, 10, TestAllocator> buffer((TestAllocator(&alloc)));
+  basic_memory_buffer<char, 10, test_allocator> buffer(
+      (test_allocator(&alloc)));
   size_t size = 2 * fmt::inline_buffer_size;
-  std::vector<char> mem(size);
+  auto mem = std::vector<char>(size);
   {
     EXPECT_CALL(alloc, allocate(size)).WillOnce(Return(&mem[0]));
     buffer.resize(size);
     std::fill(&buffer[0], &buffer[0] + size, 'x');
   }
-  std::vector<char> mem2(2 * size);
+  auto mem2 = std::vector<char>(2 * size);
   {
     EXPECT_CALL(alloc, allocate(2 * size)).WillOnce(Return(&mem2[0]));
-    std::exception e;
+    auto e = std::exception();
     EXPECT_CALL(alloc, deallocate(&mem[0], size)).WillOnce(testing::Throw(e));
     EXPECT_THROW(buffer.reserve(2 * size), std::exception);
     EXPECT_EQ(&mem2[0], &buffer[0]);
